#
# need to make atlas required, check module cmd for failure
%define releasebase  1
%define nbase scalapack
%define prefix /opt/%{nbase}/%{version}/%{compilertag}/%{mpitag}

%define _libdir %{prefix}/lib
%define _bindir %{prefix}/bin
%define modulepath /opt/Modules/modulefiles/
#Set  as deafults if no command line inputs
%define as_limulus 1
%define use_gnu4 1
# allow --with[out] <feature> at rpm command line build
%{?_with_gnu4: %{expand: %%define use_gnu4 1}}
%{?_with_pgi: %{expand: %%define use_pgi 1}}
%{?_with_intel: %{expand: %%define use_intel 1}}
%{?_with_pathsc: %{expand: %%define use_pathsc 1}}
# possible MPI's
%{?_with_mpich2: %{expand: %%define use_mpich2 1}}
%{?_with_mpich2omx: %{expand: %%define use_mpich2omx 1}}
%{?_with_ompi: %{expand: %%define use_ompi 1}}
# possible build tags
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}
#pick the target
%if "1" == "%{as_basement}"
%define targetbase Basement
%else
%define targetbase Limulus
%endif
# pick the compiler
%if "1" == "%{use_gnu4}"
%define compilertag gnu4
%endif
%if "1" == "%{use_pgi}"
%define compilertag pgi
%endif
%if "1" == "%{use_intel}"
%define compilertag intel
%endif
%if "1" == "%{use_pathsc}"
%define compilertag pathsc
%endif
%if "1" == "%{use_gnu3}"
%define compilertag gnu3
%endif
# select MPI
%if "1" == "%{use_ompi}"
%define mpitag openmpi
%endif
%if "1" == "%{use_mpich2omx}"
%define mpitag mpich2-omx
%endif
%if "1" == "%{use_mpich2}"
%define mpitag mpich2
%endif

BuildRequires: gcc-gfortran
BuildRequires: lapack-%{compilertag}, blas-%{compilertag}, modules

Group: %{targetbase}/Libraries
Release: %{releasebase}.%{targetbase}

%global _atlas_load  module load atlas-%{compilertag}; 
%global _atlas_unload  module unload atlas-%{compilertag};
%global _mpi_load  module load mpi/%{mpitag}-%{compilertag}; 
%global _mpi_unload  module unload mpi/lam%{mpitag}-%{compilertag};
%global _blacs_mpi_load  module load blacs-%{mpitag}-%{compilertag}; 
%global _blacs_mpi_unload  module unload blacs-%{mpitag}-%{compilertag};

Summary: A subset of LAPACK routines redesigned for heterogenous computing
Name: %{nbase}-%{mpitag}-%{compilertag}
Version: 1.7.5
# This is freely distributable without any restrictions.
License: Public Domain
URL: http://www.netlib.org/lapack-dev/
Source0: scalapack-%{version}.tgz
BuildRequires: lapack-%{compilertag}, blas-%{compilertag}, %{mpitag}-%{compilertag}
BuildRequires: gcc-gfortran, glibc-devel 
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Patch0: scalapack-1.7-fedora.patch

%description
The ScaLAPACK (or Scalable LAPACK) library includes a subset 
of LAPACK routines redesigned for distributed memory MIMD 
parallel computers. It is currently written in a 
Single-Program-Multiple-Data style using explicit message 
passing for interprocessor communication. It assumes 
matrices are laid out in a two-dimensional block cyclic 
decomposition.

ScaLAPACK is designed for heterogeneous computing and is 
portable on any computer that supports MPI or PVM.

Like LAPACK, the ScaLAPACK routines are based on 
block-partitioned algorithms in order to minimize the frequency 
of data movement between different levels of the memory hierarchy. 
(For such machines, the memory hierarchy includes the off-processor 
memory of other processors, in addition to the hierarchy of registers, 
cache, and local memory on each processor.) The fundamental building 
blocks of the ScaLAPACK library are distributed memory versions (PBLAS) 
of the Level 1, 2 and 3 BLAS, and a set of Basic Linear Algebra 
Communication Subprograms (BLACS) for communication tasks that arise 
frequently in parallel linear algebra computations. In the ScaLAPACK 
routines, all interprocessor communication occurs within the PBLAS and the 
BLACS. One of the design goals of ScaLAPACK was to have the ScaLAPACK 
routines resemble their LAPACK equivalents as much as possible. 

#
%prep
%setup -q -c -n %{nbase}-%{version}
%patch0 -p1
cd %{nbase}-%{version}/
#sed -i 's!BLACSdir      =.*!BLACSdir      = %{_libdir}!' SLmake.inc
cd ..
#for i in mpich2 openmpi; do
for i in %{mpitag}-%{compilertag}; do
  cp -a %{nbase}-%{version} %{name}-%{version}
#  sed -i "s|FOO|$i|g" %{name}-%{version}-$i/SLmake.inc
  sed -i "s|scalapack-1.7.5/scalapack-1.7.5-FOO|%{nbase}-%{version}/%{name}-%{version}|g" %{name}-%{version}/SLmake.inc
  sed -i 's!CBLACSLIB     =!CBLACSLIB     = -L\$(BLACSdir) !g' %{name}-%{version}/SLmake.inc
  sed -i 's!FBLACSLIB     =!FBLACSLIB     = -L\$(BLACSdir) !g' %{name}-%{version}/SLmake.inc
  sed -i 's!BLASLIB       = -lblas!BLASLIB       = -L\$(ATLAS_PATH)  -lcblas  -lf77blas -latlas  !g' %{name}-%{version}/SLmake.inc 
done
# openmpi mpicc needs -lmpi_f77 for blacs to link
%if "1" == "%{use_mpich2omx}"
 sed -i 's!CCLOADFLAGS   =!CCLOADFLAGS   = -lmpichf90 !g' %{name}-%{version}/SLmake.inc
%endif
%if "1" == "%{use_mpich2}"
 sed -i 's!CCLOADFLAGS   =!CCLOADFLAGS   = -lmpichf90 !g' %{name}-%{version}/SLmake.inc
%endif
%if "1" == "%{use_ompi}"
 sed -i 's!CCLOADFLAGS   =!CCLOADFLAGS   = -lmpi_f77 !g' %{name}-%{version}/SLmake.inc
%endif

%build
rpm -qf /opt/Modules/bin/modulecmd >& /dev/null
if [ $? -ne 0 ]; then
  echo "This RPM requries the BSC Modules package to build"
fi
. /etc/profile.d/modules.sh

%define dobuild() cd %{name}-%{version} ; sed -i 's!BLACSdir      =.*!BLACSdir      = $(BLACS_PATH)!' SLmake.inc; make lib; make exe; cd ..

export MPI_COMPILER_NAME=%{mpitag}-%{compilertag}
#check for errors here
%{_mpi_load}
%{_blacs_mpi_load}
%{_atlas_load}
RPM_OPT_FLAGS=`echo $CFLAGS`
which mpif77
echo "BLACS_PATH=$BLACS_PATH"
echo "ATLAS_PATH =$ATLAS_PATH"
%dobuild
%{_blacs_mpi_unload}
%{_mpi_unload}
%{_atlas_unload}


%install
rm -fr ${RPM_BUILD_ROOT}
mkdir -p %{buildroot}%{_libdir}

pushd %{name}-%{version}
cp -f  *.a  *.so* %{buildroot}%{_libdir}

popd
pushd %{buildroot}%{_libdir}/
ln -fs libscalapack.so.1.0.0 libscalapack.so.1
ln -s libscalapack.so.1.0.0 libscalapack.so
popd

# Copy docs
cd %{name}-%{version}
cp -f INSTALL/scalapack_install.ps ../
cp -f README ../


%post
/sbin/ldconfig 2>/dev/null
#create the module file
cat <<EOF >%{modulepath}/%{name}
#%Module1.0#######################################################################
##  %{name} modulefile
##

proc ModulesHelp { } {
        puts stderr "\tThis module loads the appropriate environment for "
        puts stderr "\tusing scalapack version %{version}.\n"
}

prereq mpi/%[mpitag}-%{compilertag}
module-whatis "scalapack %{version}"
module-log error none

set scalapackroot %{prefix}

if [ module-info mode load ] {
        setenv SCALAPACK_PATH \$scalapackroot/lib
}
if [ module-info mode remove ] {
        unsetenv SCALAPACK_PATH
}
EOF
%postun
/sbin/ldconfig 2>/dev/null
/bin/rm %{modulepath}/%{name}

%clean
rm -fr ${RPM_BUILD_ROOT}

%files
#%files common
%defattr(-,root,root,-)
%doc scalapack_install.ps README
%dir %{_libdir}
%{_libdir}/libscalapack.so.*
%{_libdir}/libscalapack.so
%{_libdir}/libscalapack.a

%changelog
* Thu Apr 28 2011 deadline <deadline@basement-supercomputing.com>
- modified for BSC cluster use, now one package for all libs in /opt
- uses BSC modules
* Tue Feb 02 2010 Deji Akingunola <dakingun@gmail.com> - 1.7.5-8.2
- Adjust the Obsoletes conditional to fix the broken dependency issue

* Wed Dec 15 2009 Deji Akingunola <dakingun@gmail.com> - 1.7.5-8.1
- mpich2 and openmpi macros can now be sanely removed
- Buildrequire mpich2-devel-static and rebuild for mpich2-1.2.1

* Wed Dec  9 2009 Tom "spot" Callaway <tcallawa@redhat.com> - 1.7.5-8
- drop lam support (Provides/Obsoletes by mpich2, which is a hack, but something's gotta do it)
- move static libs to static subpackages (resolves bz 545150)

* Thu Aug  6 2009 Tom "spot" Callaway <tcallawa@redhat.com> - 1.7.5-7
- rework package to handle all supported MPI environments in Fedora

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.7.5-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.7.5-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Tue Sep 23 2008 Tom "spot" Callaway <tcallawa@redhat.com> 1.7.5-4
- incorporate Deji Akingunola's changes (bz 462424)
- build against openmpi instead of lam

* Tue Jul  8 2008 Tom "spot" Callaway <tcallawa@redhat.com> 1.7.5-3
- fix compile against new lam paths

* Wed Feb 13 2008 Tom "spot" Callaway <tcallawa@redhat.com> 1.7.5-2
- rebuild for new gcc

* Mon Aug 27 2007 Tom "spot" Callaway <tcallawa@redhat.com> 1.7.5-1.1
- rebuild for BuildID

* Thu Jan 18 2007 Tom "spot" Callaway <tcallawa@redhat.com> 1.7.5-1
- bump to 1.7.5

* Fri Sep 15 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.7.4-4
- I said "BR" not "R". Stupid packager.

* Fri Sep 15 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.7.4-3
- fix BR: lam-devel

* Fri Sep 15 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.7.4-2
- fix 64bit patch

* Fri Sep 15 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.7.4-1
- bump to 1.7.4

* Wed Mar  8 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-13
- lam moved into _libdir/lam... need to fix patches

* Wed Mar  8 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-12
- set -fPIC as NOOPT

* Sun Feb 26 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-11
- fix 64 bit builds
- enable shared libraries
- split package into base and devel

* Tue Feb 14 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-10
- Incorporate Andrew Gormanly's fixes

* Mon Jan  9 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-9
- fix BR

* Mon Dec 19 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-8
- rebuild for gcc4.1

* Sun May 15 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-7
- 64 bit library fix

* Mon May  9 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-6
- remove hardcoded dist tags

* Sun May  8 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-4
- fix broken patch for fc-3 branch

* Sun Apr 24 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-3
- use dist tag
- fix fc3 BuildRequires

* Tue Apr 19 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-2
- fix buildroot
- add gcc-gfortran to BuildRequires (gcc-g77 for fc3)

* Mon Apr 18 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.7-1
- initial package creation
